//******************************************************************************

// @File         common_ps.glsl

// @Version       1.0

// @Created      2017, 3, 8

// @Description  This file is common_ps.glsl.

// @HISTORY:

//******************************************************************************/
highp vec4 SampleDiffuseTexture(sampler2D texture, highp vec2 uv)
{
#if defined(_USING_ALPHA_CHANNEL_) && defined(_USING_ETC1_)
	highp vec4 TexColor;

	#ifdef _REPEAT_ADDRESS_
		highp float v = uv.y - floor(uv.y);
	#else
		highp float v = clamp(uv.y, 0.0001, 0.9999);
	#endif

	TexColor.rgb = texture2D(texture, vec2(uv.x, v * 0.5)).rgb;
	TexColor.a = texture2D(texture, vec2(uv.x, v * 0.5 + 0.5)).r;

#else // #if defined(_USING_ALPHA_CHANNEL_) && defined(_USING_ETC1_)

	highp vec4 TexColor = texture2D(texture, uv);

#endif // #if defined(_USING_ALPHA_CHANNEL_) && defined(_USING_ETC1_)

	return TexColor;
}

#define XSaturate( x ) clamp(x, 0.0, 1.0)
