//******************************************************************************

// @File         sky_ps.glsl

// @Version       1.0

// @Created      2017, 3, 8

// @Description  This file is sky_ps.glsl.

// @HISTORY:

//******************************************************************************/
uniform		sampler2D		DiffuseMapCur;

#ifdef _BLEND_
uniform		sampler2D		DiffuseMapDst;
uniform		highp float		fTextureBlendWeight;
#endif

varying		highp vec4	VSOutColor0;
varying		highp vec2		VSOutTexcoord0;

#ifdef _BLEND_
varying		highp vec2		VSOutTexcoord1;
#endif

void main(void)
{
	highp vec4 vColor = texture2D(DiffuseMapCur, VSOutTexcoord0);
#ifdef _BLEND_
	highp vec4 vDstColor = texture2D(DiffuseMapDst, VSOutTexcoord1);
	vColor = mix(vColor, vDstColor, fTextureBlendWeight);
#endif

	gl_FragColor = vColor * VSOutColor0;
}
