//******************************************************************************

// @File         sky_vs.glsl

// @Version       1.0

// @Created      2017, 3, 8

// @Description  This file is sky_vs.glsl.

// @HISTORY:

//******************************************************************************/
attribute	vec3		Position0;
attribute	vec4		Color0;
attribute	vec2		Texcoord0;

uniform		mat4		WorldViewProjMatrix;

#ifdef _TRANSFORM_
uniform		mat4		CurCapCloudMatrix;
#	ifdef _BLEND_
uniform		mat4		DstCapCloudMatrix;
#	endif
#endif

varying		vec4		VSOutColor0;
varying		vec2		VSOutTexcoord0;

#ifdef _BLEND_
varying		vec2		VSOutTexcoord1;
#endif

void main(void)
{
	gl_Position = WorldViewProjMatrix * vec4(Position0, 1.0);

	VSOutColor0 = Color0.bgra;

#ifdef _TRANSFORM_
	VSOutTexcoord0 = (CurCapCloudMatrix * vec4(Texcoord0, 1.0, 0.0)).xy;
#	ifdef _BLEND_
	VSOutTexcoord1 = (DstCapCloudMatrix * vec4(Texcoord0, 1.0, 0.0)).xy;
#	endif
#else
	VSOutTexcoord0 = Texcoord0;
#	ifdef _BLEND_
	VSOutTexcoord1 = Texcoord0;
#	endif
#endif
}
